/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { FinancialDataAdapter } from "igniteui-webcomponents-core";
import { IDisposable_$type, String_$type, typeCast, fromEnum, markType } from "igniteui-webcomponents-core";
import { Fdc3Message } from "./Fdc3Message";
import { List$1 } from "igniteui-webcomponents-core";
import { Fdc3Position } from "./Fdc3Position";
import { Fdc3Instrument } from "./Fdc3Instrument";
import { Fdc3InstrumentList } from "./Fdc3InstrumentList";
import { Fdc3Portfolio } from "./Fdc3Portfolio";
import { Fdc3Converter } from "./Fdc3Converter";
import { stringIsNullOrEmpty } from "igniteui-webcomponents-core";
import { arrayClear } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
export let Fdc3DataAdapter = /*@__PURE__*/ (() => {
    class Fdc3DataAdapter extends FinancialDataAdapter {
        aq(a, b, c) {
            super.aq(a, b, c);
        }
        ba(a) {
            if (a == null) {
                return;
            }
            if (a.context != null && stringIsNullOrEmpty(a.json)) {
                a.json = a.context.toJson();
                this.log("received '" + a.intentType + "' intent '" + a.contextType + "' context with JSON:\n" + a.json);
            }
            if (this.messageReceived != null && a != null) {
                this.messageReceived(a);
            }
        }
        a5() {
            let isRunning_ = true;
            if (!window.hasOwnProperty('fin')) {
                isRunning_ = false;
            }
            ;
            return isRunning_;
        }
        subscribe(intentType_, contextType_ = "") {
            if (!this.a5()) {
                return;
            }
            if (stringIsNullOrEmpty(intentType_)) {
                intentType_ = "ViewChart";
            }
            this.log("Subscribing to '" + intentType_ + "' intent and '" + contextType_ + "' context");
            let addIntentListener_ = this._openFin.addIntentListener;
            // calling OpenFin API:
            addIntentListener_(intentType_, (context) => {
                return new Promise((resolve, reject) => {
                    try {
                        this.log('Subscriber received context ');
                        if (context.type == null || context.type === undefined) {
                            this.log('Subscriber received context with missing context.type');
                            return;
                        }
                        if (contextType_ !== '' && contextType_ !== context.type) {
                            this.log('Subscriber skipping not matching context.type');
                            return;
                        }
                        // call function to handle intent and process its context
                        this.handleIntent(context, context.type, intentType_);
                        resolve();
                    }
                    catch (e) {
                        this.log('Subscriber detected error with ' + intentType_ + ' intent: \n' + e);
                        reject(e);
                    }
                });
            });
            ;
        }
        handleIntent(context_, contextType_, intentType_) {
            let msg_ = new Fdc3Message();
            this.log("HandleIntent '" + intentType_ + "' intent with '" + contextType_ + "' context");
            msg_.intentType = intentType_;
            msg_.contextType = contextType_;
            this.log('HandleIntent');
            if (contextType_ === 'fdc3.instrument') {
                var instrument = Fdc3Converter.toInstrument(context_);
                msg_.context = instrument;
            }
            else if (contextType_ === 'fdc3.instrumentList') {
                var list = Fdc3Converter.toInstrumentList(context_);
                msg_.context = list;
            }
            else if (contextType_ === 'fdc3.position') {
                var position = Fdc3Converter.toPosition(context_);
                msg_.context = position;
            }
            else if (contextType_ === 'fdc3.portfolio') {
                var portfolio = Fdc3Converter.toPortfolio(context_);
                msg_.context = portfolio;
            }
            else // TODO other unsupported/custom context of FDC3 messages
             {
                //  var custom = Fdc3Converter.toPortfolio(context_);
                //  msg_.context = custom;
                //  this.log('received custom \n' + custom.toJson());
            }
            ;
            let a = new List$1(Fdc3Position.$, 0);
            let b = new List$1(Fdc3Instrument.$, 0);
            let c = new List$1(String_$type, 0);
            let d = new List$1(String_$type, 0);
            if (contextType_ == "fdc3.instrument") {
                this.v.clear();
                arrayClear(this.stockPrices);
                let e = typeCast(Fdc3Instrument.$, msg_.context);
                b.add(e);
                let f = e.ticker;
                if (!c.contains(f)) {
                    c.add(f);
                }
                let g = e.name;
                if (!d.contains(g)) {
                    d.add(g);
                }
            }
            else if (contextType_ == "fdc3.instrumentList") {
                this.v.clear();
                arrayClear(this.stockPrices);
                let h = typeCast(Fdc3InstrumentList.$, msg_.context);
                b.o(h.instruments);
                let k = h.instruments;
                for (let j = 0; j < k.length; j++) {
                    let i = k[j];
                    let l = i.ticker;
                    if (!c.contains(l)) {
                        c.add(l);
                    }
                    let m = i.name;
                    if (!d.contains(m)) {
                        d.add(m);
                    }
                }
            }
            else if (contextType_ == "fdc3.position") {
                let n = typeCast(Fdc3Position.$, msg_.context);
                a.add(n);
                let o = n.instrument.ticker;
                if (!c.contains(o)) {
                    c.add(n.instrument.ticker);
                }
                let p = n.instrument.name;
                if (!d.contains(p)) {
                    d.add(p);
                }
            }
            else if (contextType_ == "fdc3.portfolio") {
                this.x.clear();
                arrayClear(this.stockPositions);
                let q = typeCast(Fdc3Portfolio.$, msg_.context);
                a.o(q.positions);
                let t = q.positions;
                for (let s = 0; s < t.length; s++) {
                    let r = t[s];
                    let u = r.instrument.ticker;
                    if (!c.contains(u)) {
                        c.add(r.instrument.ticker);
                    }
                    let v = r.instrument.name;
                    if (!d.contains(v)) {
                        d.add(v);
                    }
                }
            }
            msg_.tickerSymbols = this.f(String_$type, c);
            msg_.tickerNames = this.f(String_$type, d);
            this.log("HandleIntent tickerSymbols " + msg_.tickerSymbols);
            this.log("HandleIntent instrumentList " + b.count);
            this.log("HandleIntent positionList " + a.count);
            for (let w of fromEnum(b)) {
                let x = w.ticker;
                if (stringIsNullOrEmpty(x)) {
                    continue;
                }
                let y = this.q(x);
                this.ao(x, y);
            }
            for (let z of fromEnum(a)) {
                let aa = z.instrument.ticker;
                if (stringIsNullOrEmpty(aa)) {
                    continue;
                }
                let ab = this.p(aa);
                if (z.cost > 0) {
                    ab.costPerShare = z.cost;
                }
                if (z.shares > 0) {
                    ab.shares = z.shares;
                }
                if (z.price > 0) {
                    ab.marketPrice = z.price;
                }
                this.an(aa, ab);
            }
            this.ba(msg_);
        }
        sendInstrument(a, b, c = "") {
            if (b == null) {
                return;
            }
            let d = Fdc3Converter.fromInstrument(b);
            this.bb(a, d, c);
        }
        sendInstrumentList(a, b, c = "") {
            if (b == null) {
                return;
            }
            let d = Fdc3Converter.fromInstrumentList(b);
            this.bb(a, d, c);
        }
        sendPosition(a, b, c = "") {
            if (b == null) {
                return;
            }
            let d = Fdc3Converter.fromPosition(b);
            this.bb(a, d, c);
        }
        sendPortfolio(a, b, c = "") {
            if (b == null) {
                return;
            }
            let d = Fdc3Converter.fromPortfolio(b);
            this.bb(a, d, c);
        }
        bb(intent_, context_, target_ = "") {
            if (!this.a5()) {
                return;
            }
            let raiseIntent_ = this._openFin.raiseIntent;
            this.log('Sending \'' + intent_ + '\' intent to \'' + target_ + '\' target');
            // calling OpenFin API: 
            if (target_ == null || target_ === '') {
                raiseIntent_(intent_, context_); // send to all OpenFin apps
            }
            else {
                raiseIntent_(intent_, context_, target_); // send only to Target app
            }
            ;
        }
        constructor(a) {
            super();
            this.messageReceived = null;
            this._openFin = null;
            this.a3 = false;
            this._openFin = a;
        }
        get a4() {
            return this.a3;
        }
        set a4(a) {
            this.a3 = a;
        }
        a7(a) {
            this.a4 = true;
        }
        dispose() {
            this.a7(true);
        }
    }
    Fdc3DataAdapter.$t = /*@__PURE__*/ markType(Fdc3DataAdapter, 'Fdc3DataAdapter', FinancialDataAdapter.$, [IDisposable_$type]);
    return Fdc3DataAdapter;
})();
