/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-webcomponents-core";
/**
 * Specifies type of FDC3 context
 *  https://fdc3.finos.org/docs/1.0/context-spec
 *
 */
export var Fdc3ContextType = /*@__PURE__*/ (function (Fdc3ContextType) {
    /**
     * Specifies a context that is unknown by FDC3 data adapter
     */
    Fdc3ContextType[Fdc3ContextType["Unknown"] = 0] = "Unknown";
    /**
     * Specifies FDC3 context for single instrument with stock name, stock ticker/symbol
     */
    Fdc3ContextType[Fdc3ContextType["Instrument"] = 1] = "Instrument";
    /**
     * Specifies FDC3 context for multiple instrument
     */
    Fdc3ContextType[Fdc3ContextType["InstrumentList"] = 2] = "InstrumentList";
    /**
     * Specifies FDC3 context for single position
     */
    Fdc3ContextType[Fdc3ContextType["Position"] = 3] = "Position";
    /**
     * Specifies FDC3 context for multiple positions
     */
    Fdc3ContextType[Fdc3ContextType["Portfolio"] = 4] = "Portfolio";
    /**
     * Currently not supported - Specifies FDC3 context for single contact with person name, email, phone, etc.
     */
    Fdc3ContextType[Fdc3ContextType["Contact"] = 5] = "Contact";
    /**
     * Currently not supported - Specifies FDC3 context for multiple contacts
     */
    Fdc3ContextType[Fdc3ContextType["ContactList"] = 6] = "ContactList";
    /**
     * Currently not supported - Specifies FDC3 context for single organization with company name
     */
    Fdc3ContextType[Fdc3ContextType["Organization"] = 7] = "Organization";
    /**
     * Currently not supported - Specifies FDC3 context for multiple organizations
     */
    Fdc3ContextType[Fdc3ContextType["OrganizationList"] = 8] = "OrganizationList";
    return Fdc3ContextType;
})({});
/**
 * @hidden
 */
export var Fdc3ContextType_$type = /*@__PURE__*/ markEnum('Fdc3ContextType', 'Unknown,0|Instrument,1|InstrumentList,2|Position,3|Portfolio,4|Contact,5|ContactList,6|Organization,7|OrganizationList,8');
