/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { FinancialDataAdapter } from "igniteui-webcomponents-core";
import { IDisposable_$type, String_$type, typeCast, fromEnum, markType } from "igniteui-webcomponents-core";
import { Fdc3Message } from "./Fdc3Message";
import { List$1 } from "igniteui-webcomponents-core";
import { Fdc3Position } from "./Fdc3Position";
import { Fdc3Instrument } from "./Fdc3Instrument";
import { Fdc3InstrumentList } from "./Fdc3InstrumentList";
import { Fdc3Portfolio } from "./Fdc3Portfolio";
import { Fdc3Converter } from "./Fdc3Converter";
import { stringIsNullOrEmpty } from "igniteui-webcomponents-core";
import { arrayClear } from "igniteui-webcomponents-core";
/**
 * @hidden
 */
var Fdc3DataAdapter = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3DataAdapter, _super);
    function Fdc3DataAdapter(a) {
        var _this = _super.call(this) || this;
        _this.messageReceived = null;
        _this._openFin = null;
        _this.a3 = false;
        _this._openFin = a;
        return _this;
    }
    Fdc3DataAdapter.prototype.aq = function (a, b, c) {
        _super.prototype.aq.call(this, a, b, c);
    };
    Fdc3DataAdapter.prototype.ba = function (a) {
        if (a == null) {
            return;
        }
        if (a.context != null && stringIsNullOrEmpty(a.json)) {
            a.json = a.context.toJson();
            this.log("received '" + a.intentType + "' intent '" + a.contextType + "' context with JSON:\n" + a.json);
        }
        if (this.messageReceived != null && a != null) {
            this.messageReceived(a);
        }
    };
    Fdc3DataAdapter.prototype.a5 = function () {
        var isRunning_ = true;
        if (!window.hasOwnProperty('fin')) {
            isRunning_ = false;
        }
        ;
        return isRunning_;
    };
    Fdc3DataAdapter.prototype.subscribe = function (intentType_, contextType_) {
        var _this = this;
        if (contextType_ === void 0) {
            contextType_ = "";
        }
        if (!this.a5()) {
            return;
        }
        if (stringIsNullOrEmpty(intentType_)) {
            intentType_ = "ViewChart";
        }
        this.log("Subscribing to '" + intentType_ + "' intent and '" + contextType_ + "' context");
        var addIntentListener_ = this._openFin.addIntentListener;
        // calling OpenFin API:
        addIntentListener_(intentType_, function (context) {
            return new Promise(function (resolve, reject) {
                try {
                    _this.log('Subscriber received context ');
                    if (context.type == null || context.type === undefined) {
                        _this.log('Subscriber received context with missing context.type');
                        return;
                    }
                    if (contextType_ !== '' && contextType_ !== context.type) {
                        _this.log('Subscriber skipping not matching context.type');
                        return;
                    }
                    // call function to handle intent and process its context
                    _this.handleIntent(context, context.type, intentType_);
                    resolve();
                }
                catch (e) {
                    _this.log('Subscriber detected error with ' + intentType_ + ' intent: \n' + e);
                    reject(e);
                }
            });
        });
        ;
    };
    Fdc3DataAdapter.prototype.handleIntent = function (context_, contextType_, intentType_) {
        var e_1, _a, e_2, _b;
        var msg_ = new Fdc3Message();
        this.log("HandleIntent '" + intentType_ + "' intent with '" + contextType_ + "' context");
        msg_.intentType = intentType_;
        msg_.contextType = contextType_;
        this.log('HandleIntent');
        if (contextType_ === 'fdc3.instrument') {
            var instrument = Fdc3Converter.toInstrument(context_);
            msg_.context = instrument;
        }
        else if (contextType_ === 'fdc3.instrumentList') {
            var list = Fdc3Converter.toInstrumentList(context_);
            msg_.context = list;
        }
        else if (contextType_ === 'fdc3.position') {
            var position = Fdc3Converter.toPosition(context_);
            msg_.context = position;
        }
        else if (contextType_ === 'fdc3.portfolio') {
            var portfolio = Fdc3Converter.toPortfolio(context_);
            msg_.context = portfolio;
        }
        else // TODO other unsupported/custom context of FDC3 messages
         {
            //  var custom = Fdc3Converter.toPortfolio(context_);
            //  msg_.context = custom;
            //  this.log('received custom \n' + custom.toJson());
        }
        ;
        var a = new List$1(Fdc3Position.$, 0);
        var b = new List$1(Fdc3Instrument.$, 0);
        var c = new List$1(String_$type, 0);
        var d = new List$1(String_$type, 0);
        if (contextType_ == "fdc3.instrument") {
            this.v.clear();
            arrayClear(this.stockPrices);
            var e = typeCast(Fdc3Instrument.$, msg_.context);
            b.add(e);
            var f = e.ticker;
            if (!c.contains(f)) {
                c.add(f);
            }
            var g = e.name;
            if (!d.contains(g)) {
                d.add(g);
            }
        }
        else if (contextType_ == "fdc3.instrumentList") {
            this.v.clear();
            arrayClear(this.stockPrices);
            var h = typeCast(Fdc3InstrumentList.$, msg_.context);
            b.o(h.instruments);
            var k = h.instruments;
            for (var j = 0; j < k.length; j++) {
                var i = k[j];
                var l = i.ticker;
                if (!c.contains(l)) {
                    c.add(l);
                }
                var m = i.name;
                if (!d.contains(m)) {
                    d.add(m);
                }
            }
        }
        else if (contextType_ == "fdc3.position") {
            var n = typeCast(Fdc3Position.$, msg_.context);
            a.add(n);
            var o = n.instrument.ticker;
            if (!c.contains(o)) {
                c.add(n.instrument.ticker);
            }
            var p = n.instrument.name;
            if (!d.contains(p)) {
                d.add(p);
            }
        }
        else if (contextType_ == "fdc3.portfolio") {
            this.x.clear();
            arrayClear(this.stockPositions);
            var q = typeCast(Fdc3Portfolio.$, msg_.context);
            a.o(q.positions);
            var t = q.positions;
            for (var s = 0; s < t.length; s++) {
                var r = t[s];
                var u = r.instrument.ticker;
                if (!c.contains(u)) {
                    c.add(r.instrument.ticker);
                }
                var v = r.instrument.name;
                if (!d.contains(v)) {
                    d.add(v);
                }
            }
        }
        msg_.tickerSymbols = this.f(String_$type, c);
        msg_.tickerNames = this.f(String_$type, d);
        this.log("HandleIntent tickerSymbols " + msg_.tickerSymbols);
        this.log("HandleIntent instrumentList " + b.count);
        this.log("HandleIntent positionList " + a.count);
        try {
            for (var _c = __values(fromEnum(b)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var w = _d.value;
                var x = w.ticker;
                if (stringIsNullOrEmpty(x)) {
                    continue;
                }
                var y = this.q(x);
                this.ao(x, y);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var z = _f.value;
                var aa = z.instrument.ticker;
                if (stringIsNullOrEmpty(aa)) {
                    continue;
                }
                var ab = this.p(aa);
                if (z.cost > 0) {
                    ab.costPerShare = z.cost;
                }
                if (z.shares > 0) {
                    ab.shares = z.shares;
                }
                if (z.price > 0) {
                    ab.marketPrice = z.price;
                }
                this.an(aa, ab);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        this.ba(msg_);
    };
    Fdc3DataAdapter.prototype.sendInstrument = function (a, b, c) {
        if (c === void 0) {
            c = "";
        }
        if (b == null) {
            return;
        }
        var d = Fdc3Converter.fromInstrument(b);
        this.bb(a, d, c);
    };
    Fdc3DataAdapter.prototype.sendInstrumentList = function (a, b, c) {
        if (c === void 0) {
            c = "";
        }
        if (b == null) {
            return;
        }
        var d = Fdc3Converter.fromInstrumentList(b);
        this.bb(a, d, c);
    };
    Fdc3DataAdapter.prototype.sendPosition = function (a, b, c) {
        if (c === void 0) {
            c = "";
        }
        if (b == null) {
            return;
        }
        var d = Fdc3Converter.fromPosition(b);
        this.bb(a, d, c);
    };
    Fdc3DataAdapter.prototype.sendPortfolio = function (a, b, c) {
        if (c === void 0) {
            c = "";
        }
        if (b == null) {
            return;
        }
        var d = Fdc3Converter.fromPortfolio(b);
        this.bb(a, d, c);
    };
    Fdc3DataAdapter.prototype.bb = function (intent_, context_, target_) {
        if (target_ === void 0) {
            target_ = "";
        }
        if (!this.a5()) {
            return;
        }
        var raiseIntent_ = this._openFin.raiseIntent;
        this.log('Sending \'' + intent_ + '\' intent to \'' + target_ + '\' target');
        // calling OpenFin API: 
        if (target_ == null || target_ === '') {
            raiseIntent_(intent_, context_); // send to all OpenFin apps
        }
        else {
            raiseIntent_(intent_, context_, target_); // send only to Target app
        }
        ;
    };
    Object.defineProperty(Fdc3DataAdapter.prototype, "a4", {
        get: function () {
            return this.a3;
        },
        set: function (a) {
            this.a3 = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3DataAdapter.prototype.a7 = function (a) {
        this.a4 = true;
    };
    Fdc3DataAdapter.prototype.dispose = function () {
        this.a7(true);
    };
    Fdc3DataAdapter.$t = markType(Fdc3DataAdapter, 'Fdc3DataAdapter', FinancialDataAdapter.$, [IDisposable_$type]);
    return Fdc3DataAdapter;
}(FinancialDataAdapter));
export { Fdc3DataAdapter };
