/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-webcomponents-core";
/**
 * Specifies type of FDC3 intent
 *  https://fdc3.finos.org/docs/1.0/intents-spec
 *
 */
export var Fdc3IntentType = /*@__PURE__*/ (function (Fdc3IntentType) {
    /**
     * Specifies no intent for FDC3 data adapter to listen to
     */
    Fdc3IntentType[Fdc3IntentType["None"] = 0] = "None";
    /**
     * Specifies all intents for FDC3 data adapter to listen to
     */
    Fdc3IntentType[Fdc3IntentType["All"] = 1] = "All";
    /**
     * Specifies an intent that is unknown by FDC3 data adapter
     */
    Fdc3IntentType[Fdc3IntentType["Unknown"] = 2] = "Unknown";
    /**
     * Specifies an intent to view a chart for stock tickers in the Instrument context
     */
    Fdc3IntentType[Fdc3IntentType["ViewChart"] = 3] = "ViewChart";
    /**
     * Specifies an intent to view information about stock tickers in the Instrument context
     */
    Fdc3IntentType[Fdc3IntentType["ViewInstrument"] = 4] = "ViewInstrument";
    /**
     * Currently not supported - Starts a call with Contact(s) context
     */
    Fdc3IntentType[Fdc3IntentType["StartCall"] = 5] = "StartCall";
    /**
     * Currently not supported - Starts a chat with Contact(s) context
     */
    Fdc3IntentType[Fdc3IntentType["StartChat"] = 6] = "StartChat";
    /**
     * Currently not supported - Display analysis about Instrument, Contact, or Organization
     */
    Fdc3IntentType[Fdc3IntentType["ViewAnalysis"] = 7] = "ViewAnalysis";
    /**
     * Currently not supported - Display details of the Contact context
     */
    Fdc3IntentType[Fdc3IntentType["ViewContact"] = 8] = "ViewContact";
    /**
     * Currently not supported - Display news for Instrument, Contact, or Organization
     */
    Fdc3IntentType[Fdc3IntentType["ViewNews"] = 9] = "ViewNews";
    /**
     * Currently not supported - Display pricing for the Instrument context
     */
    Fdc3IntentType[Fdc3IntentType["ViewQuote"] = 10] = "ViewQuote";
    return Fdc3IntentType;
})({});
/**
 * @hidden
 */
export var Fdc3IntentType_$type = /*@__PURE__*/ markEnum('Fdc3IntentType', 'None,0|All,1|Unknown,2|ViewChart,3|ViewInstrument,4|StartCall,5|StartChat,6|ViewAnalysis,7|ViewContact,8|ViewNews,9|ViewQuote,10');
