/*!
    THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
    https://www.infragistics.com/legal/license/igultimate-la
    https://www.infragistics.com/legal/license/igultimate-eula
    GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
  */
  
import { __extends, __values } from 'tslib';
import { markEnum, Dictionary$2, String_$type, Base, List$1, fromEnum, markType, EnumUtil, callStaticConstructors, StringBuilder, typeCast, stringIsNullOrEmpty, Boolean_$type, enumGetBox, arrayClear, FinancialDataAdapter, IDisposable_$type, truncate, Random } from 'igniteui-webcomponents-core';

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Specifies type of FDC3 intent
 *  https://fdc3.finos.org/docs/1.0/intents-spec
 *
 */
var Fdc3IntentType = /*@__PURE__*/ (function (Fdc3IntentType) {
    /**
     * Specifies no intent for FDC3 data adapter to listen to
     */
    Fdc3IntentType[Fdc3IntentType["None"] = 0] = "None";
    /**
     * Specifies all intents for FDC3 data adapter to listen to
     */
    Fdc3IntentType[Fdc3IntentType["All"] = 1] = "All";
    /**
     * Specifies an intent that is unknown by FDC3 data adapter
     */
    Fdc3IntentType[Fdc3IntentType["Unknown"] = 2] = "Unknown";
    /**
     * Specifies an intent to view a chart for stock tickers in the Instrument context
     */
    Fdc3IntentType[Fdc3IntentType["ViewChart"] = 3] = "ViewChart";
    /**
     * Specifies an intent to view information about stock tickers in the Instrument context
     */
    Fdc3IntentType[Fdc3IntentType["ViewInstrument"] = 4] = "ViewInstrument";
    /**
     * Currently not supported - Starts a call with Contact(s) context
     */
    Fdc3IntentType[Fdc3IntentType["StartCall"] = 5] = "StartCall";
    /**
     * Currently not supported - Starts a chat with Contact(s) context
     */
    Fdc3IntentType[Fdc3IntentType["StartChat"] = 6] = "StartChat";
    /**
     * Currently not supported - Display analysis about Instrument, Contact, or Organization
     */
    Fdc3IntentType[Fdc3IntentType["ViewAnalysis"] = 7] = "ViewAnalysis";
    /**
     * Currently not supported - Display details of the Contact context
     */
    Fdc3IntentType[Fdc3IntentType["ViewContact"] = 8] = "ViewContact";
    /**
     * Currently not supported - Display news for Instrument, Contact, or Organization
     */
    Fdc3IntentType[Fdc3IntentType["ViewNews"] = 9] = "ViewNews";
    /**
     * Currently not supported - Display pricing for the Instrument context
     */
    Fdc3IntentType[Fdc3IntentType["ViewQuote"] = 10] = "ViewQuote";
    return Fdc3IntentType;
})({});
/**
 * @hidden
 */
var Fdc3IntentType_$type = /*@__PURE__*/ markEnum('Fdc3IntentType', 'None,0|All,1|Unknown,2|ViewChart,3|ViewInstrument,4|StartCall,5|StartChat,6|ViewAnalysis,7|ViewContact,8|ViewNews,9|ViewQuote,10');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Fdc3Dictionary = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Dictionary, _super);
    function Fdc3Dictionary() {
        var _this = _super.call(this) || this;
        _this.d = null;
        _this.d = new Dictionary$2(String_$type, Base.$, 0);
        return _this;
    }
    Fdc3Dictionary.prototype.getKeys = function () {
        var e_1, _a;
        var a = new List$1(String_$type, 0);
        try {
            for (var _b = __values(fromEnum(this.d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a.add(b.key);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        return a.toArray();
    };
    Fdc3Dictionary.prototype.getValues = function () {
        var e_2, _a;
        var a = new List$1(Base.$, 0);
        try {
            for (var _b = __values(fromEnum(this.d)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var b = _c.value;
                a.add1(b.value);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        return a.toArray();
    };
    Fdc3Dictionary.prototype.item = function (a, b) {
        if (arguments.length === 2) {
            this.set(a, b);
            return b;
        }
        else {
            return this.get(a);
        }
    };
    Fdc3Dictionary.prototype.get = function (a) {
        if (!this.d.containsKey(a)) {
            this.set(a, "");
        }
        if (this.d.item(a) == null) {
            return "";
        }
        return this.d.item(a);
    };
    Fdc3Dictionary.prototype.h = function (a) {
        return this.get(a).toString();
    };
    Fdc3Dictionary.prototype.e = function (a) {
        if (!this.d.containsKey(a)) {
            this.set(a, 0);
            return 0;
        }
        if (this.d.item(a) == null) {
            return 0;
        }
        return parseFloat(this.d.item(a).toString());
    };
    Fdc3Dictionary.prototype.set = function (a, b) {
        if (this.d.containsKey(a)) {
            this.d.item(a, b);
        }
        else {
            this.d.addItem(a, b);
        }
    };
    Fdc3Dictionary.prototype.remove = function (a) {
        if (this.d.containsKey(a)) {
            this.d.removeItem(a);
        }
    };
    Fdc3Dictionary.prototype.contains = function (a) {
        return this.d.containsKey(a);
    };
    Fdc3Dictionary.$t = markType(Fdc3Dictionary, 'Fdc3Dictionary');
    return Fdc3Dictionary;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * Specifies type of FDC3 context
 *  https://fdc3.finos.org/docs/1.0/context-spec
 *
 */
var Fdc3ContextType = /*@__PURE__*/ (function (Fdc3ContextType) {
    /**
     * Specifies a context that is unknown by FDC3 data adapter
     */
    Fdc3ContextType[Fdc3ContextType["Unknown"] = 0] = "Unknown";
    /**
     * Specifies FDC3 context for single instrument with stock name, stock ticker/symbol
     */
    Fdc3ContextType[Fdc3ContextType["Instrument"] = 1] = "Instrument";
    /**
     * Specifies FDC3 context for multiple instrument
     */
    Fdc3ContextType[Fdc3ContextType["InstrumentList"] = 2] = "InstrumentList";
    /**
     * Specifies FDC3 context for single position
     */
    Fdc3ContextType[Fdc3ContextType["Position"] = 3] = "Position";
    /**
     * Specifies FDC3 context for multiple positions
     */
    Fdc3ContextType[Fdc3ContextType["Portfolio"] = 4] = "Portfolio";
    /**
     * Currently not supported - Specifies FDC3 context for single contact with person name, email, phone, etc.
     */
    Fdc3ContextType[Fdc3ContextType["Contact"] = 5] = "Contact";
    /**
     * Currently not supported - Specifies FDC3 context for multiple contacts
     */
    Fdc3ContextType[Fdc3ContextType["ContactList"] = 6] = "ContactList";
    /**
     * Currently not supported - Specifies FDC3 context for single organization with company name
     */
    Fdc3ContextType[Fdc3ContextType["Organization"] = 7] = "Organization";
    /**
     * Currently not supported - Specifies FDC3 context for multiple organizations
     */
    Fdc3ContextType[Fdc3ContextType["OrganizationList"] = 8] = "OrganizationList";
    return Fdc3ContextType;
})({});
/**
 * @hidden
 */
var Fdc3ContextType_$type = /*@__PURE__*/ markEnum('Fdc3ContextType', 'Unknown,0|Instrument,1|InstrumentList,2|Position,3|Portfolio,4|Contact,5|ContactList,6|Organization,7|OrganizationList,8');

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Fdc3Util = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Util, _super);
    function Fdc3Util() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Fdc3Util.staticInit = function () {
        Fdc3Util.c = new Dictionary$2(String_$type, Fdc3ContextType_$type, 0);
        Fdc3Util.f(0);
        Fdc3Util.f(1);
        Fdc3Util.f(2);
        Fdc3Util.f(3);
        Fdc3Util.f(4);
        Fdc3Util.f(7);
        Fdc3Util.f(8);
        Fdc3Util.f(5);
        Fdc3Util.f(6);
        Fdc3Util.d = new Dictionary$2(String_$type, Fdc3IntentType_$type, 0);
        Fdc3Util.g(2);
        Fdc3Util.g(3);
        Fdc3Util.g(4);
        Fdc3Util.g(7);
        Fdc3Util.g(5);
        Fdc3Util.g(6);
        Fdc3Util.g(8);
        Fdc3Util.g(10);
        Fdc3Util.g(9);
    };
    Fdc3Util.getString = function (a) {
        var b = EnumUtil.getName(Fdc3ContextType_$type, a);
        return "fdc3." + b.substr(0, 1).toLowerCase() + b.substr(1);
    };
    Fdc3Util.a = function (a) {
        if (Fdc3Util.c.containsKey(a)) {
            return Fdc3Util.c.item(a);
        }
        else {
            return 0;
        }
    };
    Fdc3Util.b = function (a) {
        if (Fdc3Util.d.containsKey(a)) {
            return Fdc3Util.d.item(a);
        }
        else {
            return 2;
        }
    };
    Fdc3Util.f = function (a) {
        var b = Fdc3Util.getString(a);
        if (!Fdc3Util.c.containsKey(b)) {
            Fdc3Util.c.addItem(b, a);
        }
    };
    Fdc3Util.g = function (a) {
        var b = EnumUtil.getName(Fdc3IntentType_$type, a);
        if (!Fdc3Util.d.containsKey(b)) {
            Fdc3Util.d.addItem(b, a);
        }
    };
    Fdc3Util.$t = markType(Fdc3Util, 'Fdc3Util');
    Fdc3Util.c = null;
    Fdc3Util.d = null;
    return Fdc3Util;
}(Base));
(function (v) { callStaticConstructors(); })(true);

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Fdc3Serializer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Serializer, _super);
    function Fdc3Serializer() {
        var _this = _super.call(this) || this;
        _this._sb = null;
        _this.m = 0;
        _this.l = false;
        _this._sb = new StringBuilder(0);
        return _this;
    }
    Fdc3Serializer.prototype.toString = function () {
        return this._sb.toString();
    };
    Fdc3Serializer.prototype.toJson = function (a) {
        this._sb.v();
        if (typeCast(Fdc3Instrument.$, a) !== null) {
            this.add4(typeCast(Fdc3Instrument.$, a));
        }
        else if (typeCast(Fdc3InstrumentList.$, a) !== null) {
            this.add5(typeCast(Fdc3InstrumentList.$, a));
        }
        else if (typeCast(Fdc3Position.$, a) !== null) {
            this.add9(typeCast(Fdc3Position.$, a));
        }
        else if (typeCast(Fdc3Portfolio.$, a) !== null) {
            this.add8(typeCast(Fdc3Portfolio.$, a));
        }
        else if (typeCast(Fdc3Contact.$, a) !== null) {
            this.add1(typeCast(Fdc3Contact.$, a));
        }
        else if (typeCast(Fdc3ContactList.$, a) !== null) {
            this.add2(typeCast(Fdc3ContactList.$, a));
        }
        else if (typeCast(Fdc3Organization.$, a) !== null) {
            this.add6(typeCast(Fdc3Organization.$, a));
        }
        else if (typeCast(Fdc3OrganizationList.$, a) !== null) {
            this.add7(typeCast(Fdc3OrganizationList.$, a));
        }
        else {
            this.add3(typeCast(Fdc3Context.$, a));
        }
        return this.toString();
    };
    Fdc3Serializer.prototype.add4 = function (a, b) {
        if (b === void 0) {
            b = "";
        }
        this.z("serializing Fdc3Instrument");
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var e = a.getKeys();
        for (var d = 0; d < e.length; d++) {
            var c = e[d];
            if (c == "type") {
                continue;
            }
            if (c == "name") {
                continue;
            }
            if (c == "target") {
                continue;
            }
            if (c == "intent") {
                continue;
            }
            if (c == "ticker") {
                continue;
            }
            if (c != "id") {
                this.addProp1(c, a.item(c));
            }
        }
        if (a.id == null) {
            this.addProp1("id", "null");
        }
        else {
            this.addProp("id");
            this.addObjectOpen();
            this.addProp1("ticker", a.ticker);
            var h = a.id.getKeys();
            for (var g = 0; g < h.length; g++) {
                var f = h[g];
                if (f == "ticker") {
                    continue;
                }
                this.addProp1(f, a.id.item(f));
            }
            this.addObjectClose();
        }
        this.addObjectClose(b);
    };
    Fdc3Serializer.prototype.add5 = function (a) {
        this.z("serializing Fdc3InstrumentList");
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var d = a.getKeys();
        for (var c = 0; c < d.length; c++) {
            var b = d[c];
            if (b == "type") {
                continue;
            }
            if (b == "name") {
                continue;
            }
            if (b == "target") {
                continue;
            }
            if (b == "intent") {
                continue;
            }
            if (b == "id") {
                continue;
            }
            if (b != "instruments") {
                this.addProp1(b, a.item(b));
            }
        }
        if (a.instruments == null) {
            this.addProp1("instruments", "null");
        }
        else {
            this.addProp("instruments");
            this.addArrayOpen();
            var g = a.instruments;
            for (var f = 0; f < g.length; f++) {
                var e = g[f];
                this.add4(e, ",");
            }
            this.addArrayClose();
        }
        this.addObjectClose();
    };
    Fdc3Serializer.prototype.add8 = function (a) {
        this.z("serializing Fdc3Portfolio");
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var d = a.getKeys();
        for (var c = 0; c < d.length; c++) {
            var b = d[c];
            if (b == "type") {
                continue;
            }
            if (b == "name") {
                continue;
            }
            if (b == "target") {
                continue;
            }
            if (b == "intent") {
                continue;
            }
            if (b == "id") {
                continue;
            }
            if (b != "positions") {
                this.addProp1(b, a.item(b));
            }
        }
        if (a.positions == null) {
            this.addProp1("positions", "null");
        }
        else {
            this.addProp("positions");
            this.addArrayOpen();
            var g = a.positions;
            for (var f = 0; f < g.length; f++) {
                var e = g[f];
                this.add9(e, ",");
            }
            this.addArrayClose();
        }
        this.addObjectClose();
    };
    Fdc3Serializer.prototype.add9 = function (a, b) {
        if (b === void 0) {
            b = "";
        }
        this.z("serializing Fdc3Position");
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var e = a.getKeys();
        for (var d = 0; d < e.length; d++) {
            var c = e[d];
            if (c == "type") {
                continue;
            }
            if (c == "name") {
                continue;
            }
            if (c == "target") {
                continue;
            }
            if (c == "intent") {
                continue;
            }
            if (c == "id") {
                continue;
            }
            if (c != "instrument") {
                this.addProp1(c, a.item(c));
            }
        }
        if (a.instrument == null) {
            this.addProp1("instrument", "null");
        }
        else {
            this.addProp("instrument");
            this.add4(a.instrument, ",");
        }
        this.addObjectClose(b);
    };
    Fdc3Serializer.prototype.add1 = function (a, b) {
        if (b === void 0) {
            b = "";
        }
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var e = a.getKeys();
        for (var d = 0; d < e.length; d++) {
            var c = e[d];
            if (c == "type") {
                continue;
            }
            if (c == "name") {
                continue;
            }
            if (c == "target") {
                continue;
            }
            if (c == "intent") {
                continue;
            }
            if (c == "email") {
                continue;
            }
            if (c == "phone") {
                continue;
            }
            if (c != "id") {
                this.addProp1(c, a.item(c));
            }
        }
        if (a.id == null) {
            this.addProp1("id", "null");
        }
        else {
            this.addProp("id");
            this.addObjectOpen();
            var h = a.id.getKeys();
            for (var g = 0; g < h.length; g++) {
                var f = h[g];
                this.addProp1(f, a.id.item(f));
            }
            this.addObjectClose();
        }
        this.addObjectClose(b);
    };
    Fdc3Serializer.prototype.z = function (message_) {
    };
    Fdc3Serializer.prototype.add2 = function (a) {
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var d = a.getKeys();
        for (var c = 0; c < d.length; c++) {
            var b = d[c];
            if (b == "type") {
                continue;
            }
            if (b == "name") {
                continue;
            }
            if (b == "target") {
                continue;
            }
            if (b == "intent") {
                continue;
            }
            if (b == "id") {
                continue;
            }
            if (b != "contacts") {
                this.addProp1(b, a.item(b));
            }
        }
        if (a.contacts == null) {
            this.addProp1("contacts", "null");
        }
        else {
            this.addProp("contacts");
            this.addArrayOpen();
            var g = a.contacts;
            for (var f = 0; f < g.length; f++) {
                var e = g[f];
                this.add1(e, ",");
            }
            this.addArrayClose();
        }
        this.addObjectClose();
    };
    Fdc3Serializer.prototype.add6 = function (a, b) {
        if (b === void 0) {
            b = "";
        }
        this.z("serializing Fdc3Organization");
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var e = a.getKeys();
        for (var d = 0; d < e.length; d++) {
            var c = e[d];
            if (c == "type") {
                continue;
            }
            if (c == "name") {
                continue;
            }
            if (c == "target") {
                continue;
            }
            if (c == "intent") {
                continue;
            }
            if (c == "email") {
                continue;
            }
            if (c == "phone") {
                continue;
            }
            if (c != "id") {
                this.addProp1(c, a.item(c));
            }
        }
        if (a.id == null) {
            this.addProp1("id", "null");
        }
        else {
            this.addProp("id");
            this.addObjectOpen();
            var h = a.id.getKeys();
            for (var g = 0; g < h.length; g++) {
                var f = h[g];
                this.addProp1(f, a.id.item(f));
            }
            this.addObjectClose();
        }
        this.addObjectClose(b);
    };
    Fdc3Serializer.prototype.add7 = function (a) {
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var d = a.getKeys();
        for (var c = 0; c < d.length; c++) {
            var b = d[c];
            if (b == "type") {
                continue;
            }
            if (b == "name") {
                continue;
            }
            if (b == "target") {
                continue;
            }
            if (b == "intent") {
                continue;
            }
            if (b == "id") {
                continue;
            }
            if (b != "organizations") {
                this.addProp1(b, a.item(b));
            }
        }
        if (a.organizations == null) {
            this.addProp1("organizations", "null");
        }
        else {
            this.addProp("organizations");
            this.addArrayOpen();
            var g = a.organizations;
            for (var f = 0; f < g.length; f++) {
                var e = g[f];
                this.add4(e, ",");
            }
            this.addArrayClose();
        }
        this.addObjectClose();
    };
    Fdc3Serializer.prototype.add3 = function (a, b) {
        if (b === void 0) {
            b = "";
        }
        this.z("serializing Fdc3Context");
        this.addObjectOpen();
        this.addProp1("type", a.type);
        if (!stringIsNullOrEmpty(a.target)) {
            this.addProp1("target", a.target);
        }
        if (a.intent != 2) {
            this.addProp1("intent", EnumUtil.getName(Fdc3IntentType_$type, a.intent));
        }
        if (!stringIsNullOrEmpty(a.name)) {
            this.addProp1("name", a.name);
        }
        var e = a.getKeys();
        for (var d = 0; d < e.length; d++) {
            var c = e[d];
            if (c == "type") {
                continue;
            }
            if (c == "name") {
                continue;
            }
            if (c == "target") {
                continue;
            }
            if (c == "intent") {
                continue;
            }
            if (c != "id") {
                this.addProp1(c, a.item(c));
            }
        }
        if (a.id == null) {
            this.addProp1("id", "null");
        }
        else {
            this.addProp("id");
            this.addObjectOpen();
            var h = a.id.getKeys();
            for (var g = 0; g < h.length; g++) {
                var f = h[g];
                this.addProp1(f, a.id.item(f));
            }
            this.addObjectClose();
        }
        this.addObjectClose(b);
    };
    Fdc3Serializer.prototype.addArrayOpen = function () {
        this.addLine("[");
        this.tabIncrease();
        return this;
    };
    Fdc3Serializer.prototype.addArrayClose = function (a) {
        if (a === void 0) {
            a = "";
        }
        this.tabDecrease();
        this.addLine("]" + a);
        return this;
    };
    Fdc3Serializer.prototype.addObjectOpen = function () {
        this.addLine("{");
        this.tabIncrease();
        return this;
    };
    Fdc3Serializer.prototype.addObjectClose = function (a) {
        if (a === void 0) {
            a = "";
        }
        this.tabDecrease();
        this.addLine("}" + a);
        return this;
    };
    Fdc3Serializer.prototype.add = function (a) {
        this.i();
        this._sb.l(a);
        return this;
    };
    Fdc3Serializer.prototype.addLine = function (a) {
        this.i();
        this._sb.u(a);
        this.l = true;
        return this;
    };
    Fdc3Serializer.prototype.addProp = function (a) {
        this.i();
        this._sb.u("\"" + a + "\": ");
        this.l = true;
        return this;
    };
    Fdc3Serializer.prototype.addProp1 = function (a, b, c) {
        if (c === void 0) {
            c = "";
        }
        this.i();
        if (!stringIsNullOrEmpty(c)) {
            c = " // " + c;
        }
        var d = b == null ? "null" : b;
        if (typeof b === 'string') {
            this._sb.u("\"" + a + "\": \"" + d + "\"," + c);
        }
        else if (typeCast(Boolean_$type, b) !== null) {
            var e = d.toString().toLowerCase();
            this._sb.u("\"" + a + "\": " + e + "," + c);
        }
        else {
            this._sb.u("\"" + a + "\": " + d + "," + c);
        }
        this.l = true;
        return this;
    };
    Fdc3Serializer.prototype.i = function () {
        if (this.l) {
            for (var a = 0; a < this.m; a++) {
                this._sb.l("    ");
            }
            this.l = false;
        }
        return this;
    };
    Fdc3Serializer.prototype.tabIncrease = function () {
        this.m++;
        return this;
    };
    Fdc3Serializer.prototype.tabDecrease = function () {
        this.m--;
        return this;
    };
    Fdc3Serializer.$t = markType(Fdc3Serializer, 'Fdc3Serializer');
    return Fdc3Serializer;
}(Base));
/**
 * @hidden
 */
var Fdc3Context = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Context, _super);
    function Fdc3Context(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this._id = null;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = [0];
                    {
                        var e = c[0];
                        _this.type = Fdc3Util.getString(e);
                        _this.id = new Fdc3Dictionary();
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    _this.type = Fdc3Util.getString(c);
                    _this.id = new Fdc3Dictionary();
                }
                break;
        }
        return _this;
    }
    Object.defineProperty(Fdc3Context.prototype, "intent", {
        get: function () {
            return Fdc3Util.b(this.item("intent").toString());
        },
        set: function (a) {
            this.item("intent", enumGetBox(Fdc3IntentType_$type, a));
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Context.prototype, "type", {
        get: function () {
            return this.item("type").toString();
        },
        set: function (a) {
            this.item("type", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Context.prototype, "target", {
        get: function () {
            return this.h("target");
        },
        set: function (a) {
            this.item("target", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Context.prototype, "name", {
        get: function () {
            return this.h("name");
        },
        set: function (a) {
            this.item("name", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Context.prototype, "id", {
        get: function () {
            return this._id;
        },
        set: function (a) {
            this._id = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3Context.prototype.toJson = function () {
        var a = new Fdc3Serializer();
        var b = a.toJson(this);
        return b;
    };
    Fdc3Context.$t = markType(Fdc3Context, 'Fdc3Context', Fdc3Dictionary.$);
    return Fdc3Context;
}(Fdc3Dictionary));
/**
 * @hidden
 */
var Fdc3Instrument = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Instrument, _super);
    function Fdc3Instrument() {
        return _super.call(this, 1, 1) || this;
    }
    Object.defineProperty(Fdc3Instrument.prototype, "ticker", {
        get: function () {
            return this.id.item("ticker").toString();
        },
        set: function (a) {
            this.id.item("ticker", a);
        },
        enumerable: false,
        configurable: true
    });
    Fdc3Instrument.$t = markType(Fdc3Instrument, 'Fdc3Instrument', Fdc3Context.$);
    return Fdc3Instrument;
}(Fdc3Context));
/**
 * @hidden
 */
var Fdc3InstrumentList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3InstrumentList, _super);
    function Fdc3InstrumentList() {
        var _this = _super.call(this, 0) || this;
        _this._instruments = null;
        _this.type = Fdc3Util.getString(2);
        _this.instruments = new Array(0);
        return _this;
    }
    Object.defineProperty(Fdc3InstrumentList.prototype, "instruments", {
        get: function () {
            return this._instruments;
        },
        set: function (a) {
            this._instruments = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3InstrumentList.$t = markType(Fdc3InstrumentList, 'Fdc3InstrumentList', Fdc3Context.$);
    return Fdc3InstrumentList;
}(Fdc3Context));
/**
 * @hidden
 */
var Fdc3Position = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Position, _super);
    function Fdc3Position() {
        var _this = _super.call(this, 1, 3) || this;
        _this.instrument = new Fdc3Instrument();
        return _this;
    }
    Object.defineProperty(Fdc3Position.prototype, "instrument", {
        get: function () {
            return typeCast(Fdc3Instrument.$, this.item("instrument"));
        },
        set: function (a) {
            this.item("instrument", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Position.prototype, "shares", {
        get: function () {
            return this.e("shares");
        },
        set: function (a) {
            this.item("shares", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Position.prototype, "cost", {
        get: function () {
            return this.e("cost");
        },
        set: function (a) {
            this.item("cost", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Position.prototype, "price", {
        get: function () {
            return this.e("price");
        },
        set: function (a) {
            this.item("price", a);
        },
        enumerable: false,
        configurable: true
    });
    Fdc3Position.$t = markType(Fdc3Position, 'Fdc3Position', Fdc3Context.$);
    return Fdc3Position;
}(Fdc3Context));
/**
 * @hidden
 */
var Fdc3Portfolio = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Portfolio, _super);
    function Fdc3Portfolio() {
        var _this = _super.call(this, 1, 4) || this;
        _this._positions = null;
        _this.positions = new Array(0);
        return _this;
    }
    Object.defineProperty(Fdc3Portfolio.prototype, "positions", {
        get: function () {
            return this._positions;
        },
        set: function (a) {
            this._positions = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3Portfolio.$t = markType(Fdc3Portfolio, 'Fdc3Portfolio', Fdc3Context.$);
    return Fdc3Portfolio;
}(Fdc3Context));
/**
 * @hidden
 */
var Fdc3Organization = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Organization, _super);
    function Fdc3Organization() {
        return _super.call(this, 1, 7) || this;
    }
    Fdc3Organization.$t = markType(Fdc3Organization, 'Fdc3Organization', Fdc3Context.$);
    return Fdc3Organization;
}(Fdc3Context));
/**
 * @hidden
 */
var Fdc3OrganizationList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3OrganizationList, _super);
    function Fdc3OrganizationList() {
        var _this = _super.call(this, 1, 8) || this;
        _this._organizations = null;
        return _this;
    }
    Object.defineProperty(Fdc3OrganizationList.prototype, "organizations", {
        get: function () {
            return this._organizations;
        },
        set: function (a) {
            this._organizations = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3OrganizationList.$t = markType(Fdc3OrganizationList, 'Fdc3OrganizationList', Fdc3Context.$);
    return Fdc3OrganizationList;
}(Fdc3Context));
/**
 * @hidden
 */
var Fdc3Contact = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Contact, _super);
    function Fdc3Contact(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    var c = ["", "", "", ""];
                    {
                        var e = c[0];
                        var f = c[1];
                        var g = c[2];
                        var h = c[3];
                        _this = _super.call(this, 1, 5) || this;
                        _this.name = e;
                        _this.email = f;
                        _this.phone = g;
                        _this.twitter = h;
                    }
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    var e = _rest[2];
                    var f = _rest[3];
                    _this = _super.call(this, 1, 5) || this;
                    _this.name = c;
                    _this.email = d;
                    _this.phone = e;
                    _this.twitter = f;
                }
                break;
        }
        return _this;
    }
    Object.defineProperty(Fdc3Contact.prototype, "email", {
        get: function () {
            return this.id.item("email").toString();
        },
        set: function (a) {
            this.id.item("email", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Contact.prototype, "phone", {
        get: function () {
            return this.id.item("phone").toString();
        },
        set: function (a) {
            this.id.item("phone", a);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Contact.prototype, "twitter", {
        get: function () {
            return this.id.item("twitter").toString();
        },
        set: function (a) {
            this.id.item("twitter", a);
        },
        enumerable: false,
        configurable: true
    });
    Fdc3Contact.$t = markType(Fdc3Contact, 'Fdc3Contact', Fdc3Context.$);
    return Fdc3Contact;
}(Fdc3Context));
/**
 * @hidden
 */
var Fdc3ContactList = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3ContactList, _super);
    function Fdc3ContactList(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = this;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0:
                {
                    _this = _super.call(this, 1, 6) || this;
                    _this._contacts = null;
                    _this.contacts = new Array(0);
                }
                break;
            case 1:
                {
                    var c = _rest[0];
                    {
                        _this = _super.call(this, 1, 6) || this;
                        _this._contacts = null;
                        _this.contacts = new Array(0);
                    }
                    _this.contacts = c;
                }
                break;
        }
        return _this;
    }
    Object.defineProperty(Fdc3ContactList.prototype, "contacts", {
        get: function () {
            return this._contacts;
        },
        set: function (a) {
            this._contacts = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3ContactList.$t = markType(Fdc3ContactList, 'Fdc3ContactList', Fdc3Context.$);
    return Fdc3ContactList;
}(Fdc3Context));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Fdc3Converter = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Converter, _super);
    function Fdc3Converter() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Fdc3Converter.log = function (message_) {
    };
    Fdc3Converter.toInstrument = function (context_) {
        var instrument_ = new Fdc3Instrument();
        if (context_ == null) {
            return instrument_;
        }
        // Fdc3Converter.log('converting to Instrument');
        var propNames = Object.getOwnPropertyNames(context_);
        for (var i = 0; i < propNames.length; i++) {
            var prop = propNames[i];
            if (prop === 'id') {
                var propIDs = Object.getOwnPropertyNames(context_[prop]);
                for (var ii = 0; ii < propIDs.length; ii++) {
                    var id = propIDs[ii];
                    instrument_.id.set(id, context_[prop][id]);
                }
            }
            else {
                instrument_.set(prop, context_[prop]);
            }
        }
        ;
        return instrument_;
    };
    Fdc3Converter.toInstrumentList = function (context_) {
        var list_ = new Fdc3InstrumentList();
        if (context_ == null) {
            return list_;
        }
        // Fdc3Converter.log('converting to InstrumentList'); 
        var propNames = Object.getOwnPropertyNames(context_);
        for (var i = 0; i < propNames.length; i++) {
            var prop = propNames[i];
            if (context_[prop] instanceof Array) {
                var array = context_[prop];
                for (var ii = 0; ii < array.length; ii++) {
                    var item = array[ii];
                    if (item['type'] === 'fdc3.instrument') {
                        var instrument = this.toInstrument(item);
                        list_.instruments.push(instrument);
                    }
                }
            }
            else {
                list_.set(prop, context_[prop]);
            }
        }
        ;
        return list_;
    };
    Fdc3Converter.toPosition = function (context_) {
        var position_ = new Fdc3Position();
        if (context_ == null) {
            return position_;
        }
        // Fdc3Converter.log('converting to Position');
        var propNames = Object.getOwnPropertyNames(context_);
        for (var i = 0; i < propNames.length; i++) {
            var prop = propNames[i];
            if (prop === 'instrument') {
                var inst = Fdc3Converter.toInstrument(context_[prop]);
                position_.instrument = inst;
            }
            else {
                position_.set(prop, context_[prop]);
            }
        }
        ;
        return position_;
    };
    Fdc3Converter.toPortfolio = function (context_) {
        var portfolio_ = new Fdc3Portfolio();
        if (context_ == null) {
            return portfolio_;
        }
        // Fdc3Converter.log('converting to Portfolio'); 
        var propNames = Object.getOwnPropertyNames(context_);
        for (var i = 0; i < propNames.length; i++) {
            var prop = propNames[i];
            if (context_[prop] instanceof Array) {
                // Fdc3Converter.log('array ');
                var array = context_[prop];
                for (var ii = 0; ii < array.length; ii++) {
                    var item = array[ii];
                    if (item['type'] === 'fdc3.position') {
                        var position_ = Fdc3Converter.toPosition(item);
                        portfolio_.positions.push(position_);
                    }
                }
            }
            else {
                portfolio_.set(prop, context_[prop]);
            }
        }
        ;
        return portfolio_;
    };
    Fdc3Converter.fromPortfolio = function (portfolio_) {
        var context_ = null;
        if (portfolio_ == null) {
            return context_;
        }
        // Fdc3Converter.log('converting from Portfolio'); 
        context_ = {};
        var propNames = portfolio_.getKeys();
        for (var i = 0; i < propNames.length; i++) {
            var prop = propNames[i];
            context_[prop] = portfolio_.item(prop);
        }
        context_.positions = [];
        for (var i = 0; i < portfolio_.positions.length; i++) {
            var position_ = portfolio_.positions[i];
            var item = Fdc3Converter.fromPosition(position_);
            context_.positions.push(item);
        }
        ;
        return context_;
    };
    Fdc3Converter.fromPosition = function (position_) {
        var context_ = null;
        if (position_ == null) {
            return context_;
        }
        // Fdc3Converter.log('converting from position');  
        context_ = {};
        var propNames = position_.getKeys();
        for (var i = 0; i < propNames.length; i++) {
            var prop = propNames[i];
            context_[prop] = position_.item(prop);
        }
        context_.instrument = Fdc3Converter.fromInstrument(position_.instrument);
        ;
        return context_;
    };
    Fdc3Converter.fromInstrumentList = function (list_) {
        var context_ = null;
        if (list_ == null) {
            return context_;
        }
        // Fdc3Converter.log('converting from InstrumentList');   
        context_ = {};
        var propNames = list_.getKeys();
        for (var i = 0; i < propNames.length; i++) {
            var prop = propNames[i];
            context_[prop] = list_.item(prop);
        }
        context_.instruments = [];
        for (var i = 0; i < list_.instruments.length; i++) {
            var instrument = list_.instruments[i];
            var item = Fdc3Converter.fromInstrument(instrument);
            context_.instruments.push(item);
        }
        ;
        return context_;
    };
    Fdc3Converter.fromInstrument = function (instrument_) {
        var context_ = null;
        if (instrument_ == null) {
            return context_;
        }
        // Fdc3Converter.log('converting from Instrument');    
        context_ = {};
        var propNames = instrument_.getKeys();
        for (var i = 0; i < propNames.length; i++) {
            var prop = propNames[i];
            context_[prop] = instrument_.item(prop);
        }
        context_.id = {};
        var propIDs = instrument_.id.getKeys();
        for (var i = 0; i < propIDs.length; i++) {
            var prop = propIDs[i];
            context_.id[prop] = instrument_.id.item(prop);
        }
        ;
        return context_;
    };
    Fdc3Converter.$t = markType(Fdc3Converter, 'Fdc3Converter');
    return Fdc3Converter;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Fdc3Message = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3Message, _super);
    function Fdc3Message() {
        var _this = _super.call(this) || this;
        _this._tickerSymbols = null;
        _this._tickerNames = null;
        _this._json = null;
        _this._context = null;
        _this._intentType = null;
        _this._contextType = null;
        _this.tickerNames = new Array(0);
        _this.tickerSymbols = new Array(0);
        return _this;
    }
    Object.defineProperty(Fdc3Message.prototype, "tickerSymbols", {
        get: function () {
            return this._tickerSymbols;
        },
        set: function (a) {
            this._tickerSymbols = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Message.prototype, "tickerNames", {
        get: function () {
            return this._tickerNames;
        },
        set: function (a) {
            this._tickerNames = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Message.prototype, "json", {
        get: function () {
            return this._json;
        },
        set: function (a) {
            this._json = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Message.prototype, "context", {
        get: function () {
            return this._context;
        },
        set: function (a) {
            this._context = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Message.prototype, "intentType", {
        get: function () {
            return this._intentType;
        },
        set: function (a) {
            this._intentType = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(Fdc3Message.prototype, "contextType", {
        get: function () {
            return this._contextType;
        },
        set: function (a) {
            this._contextType = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3Message.$t = markType(Fdc3Message, 'Fdc3Message');
    return Fdc3Message;
}(Base));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Fdc3DataAdapter = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Fdc3DataAdapter, _super);
    function Fdc3DataAdapter(a) {
        var _this = _super.call(this) || this;
        _this.messageReceived = null;
        _this._openFin = null;
        _this.a3 = false;
        _this._openFin = a;
        return _this;
    }
    Fdc3DataAdapter.prototype.aq = function (a, b, c) {
        _super.prototype.aq.call(this, a, b, c);
    };
    Fdc3DataAdapter.prototype.ba = function (a) {
        if (a == null) {
            return;
        }
        if (a.context != null && stringIsNullOrEmpty(a.json)) {
            a.json = a.context.toJson();
            this.log("received '" + a.intentType + "' intent '" + a.contextType + "' context with JSON:\n" + a.json);
        }
        if (this.messageReceived != null && a != null) {
            this.messageReceived(a);
        }
    };
    Fdc3DataAdapter.prototype.a5 = function () {
        var isRunning_ = true;
        if (!window.hasOwnProperty('fin')) {
            isRunning_ = false;
        }
        ;
        return isRunning_;
    };
    Fdc3DataAdapter.prototype.subscribe = function (intentType_, contextType_) {
        var _this = this;
        if (contextType_ === void 0) {
            contextType_ = "";
        }
        if (!this.a5()) {
            return;
        }
        if (stringIsNullOrEmpty(intentType_)) {
            intentType_ = "ViewChart";
        }
        this.log("Subscribing to '" + intentType_ + "' intent and '" + contextType_ + "' context");
        var addIntentListener_ = this._openFin.addIntentListener;
        // calling OpenFin API:
        addIntentListener_(intentType_, function (context) {
            return new Promise(function (resolve, reject) {
                try {
                    _this.log('Subscriber received context ');
                    if (context.type == null || context.type === undefined) {
                        _this.log('Subscriber received context with missing context.type');
                        return;
                    }
                    if (contextType_ !== '' && contextType_ !== context.type) {
                        _this.log('Subscriber skipping not matching context.type');
                        return;
                    }
                    // call function to handle intent and process its context
                    _this.handleIntent(context, context.type, intentType_);
                    resolve();
                }
                catch (e) {
                    _this.log('Subscriber detected error with ' + intentType_ + ' intent: \n' + e);
                    reject(e);
                }
            });
        });
        ;
    };
    Fdc3DataAdapter.prototype.handleIntent = function (context_, contextType_, intentType_) {
        var e_1, _a, e_2, _b;
        var msg_ = new Fdc3Message();
        this.log("HandleIntent '" + intentType_ + "' intent with '" + contextType_ + "' context");
        msg_.intentType = intentType_;
        msg_.contextType = contextType_;
        this.log('HandleIntent');
        if (contextType_ === 'fdc3.instrument') {
            var instrument = Fdc3Converter.toInstrument(context_);
            msg_.context = instrument;
        }
        else if (contextType_ === 'fdc3.instrumentList') {
            var list = Fdc3Converter.toInstrumentList(context_);
            msg_.context = list;
        }
        else if (contextType_ === 'fdc3.position') {
            var position = Fdc3Converter.toPosition(context_);
            msg_.context = position;
        }
        else if (contextType_ === 'fdc3.portfolio') {
            var portfolio = Fdc3Converter.toPortfolio(context_);
            msg_.context = portfolio;
        }
        else // TODO other unsupported/custom context of FDC3 messages
         {
            //  var custom = Fdc3Converter.toPortfolio(context_);
            //  msg_.context = custom;
            //  this.log('received custom \n' + custom.toJson());
        }
        ;
        var a = new List$1(Fdc3Position.$, 0);
        var b = new List$1(Fdc3Instrument.$, 0);
        var c = new List$1(String_$type, 0);
        var d = new List$1(String_$type, 0);
        if (contextType_ == "fdc3.instrument") {
            this.v.clear();
            arrayClear(this.stockPrices);
            var e = typeCast(Fdc3Instrument.$, msg_.context);
            b.add(e);
            var f = e.ticker;
            if (!c.contains(f)) {
                c.add(f);
            }
            var g = e.name;
            if (!d.contains(g)) {
                d.add(g);
            }
        }
        else if (contextType_ == "fdc3.instrumentList") {
            this.v.clear();
            arrayClear(this.stockPrices);
            var h = typeCast(Fdc3InstrumentList.$, msg_.context);
            b.o(h.instruments);
            var k = h.instruments;
            for (var j = 0; j < k.length; j++) {
                var i = k[j];
                var l = i.ticker;
                if (!c.contains(l)) {
                    c.add(l);
                }
                var m = i.name;
                if (!d.contains(m)) {
                    d.add(m);
                }
            }
        }
        else if (contextType_ == "fdc3.position") {
            var n = typeCast(Fdc3Position.$, msg_.context);
            a.add(n);
            var o = n.instrument.ticker;
            if (!c.contains(o)) {
                c.add(n.instrument.ticker);
            }
            var p = n.instrument.name;
            if (!d.contains(p)) {
                d.add(p);
            }
        }
        else if (contextType_ == "fdc3.portfolio") {
            this.x.clear();
            arrayClear(this.stockPositions);
            var q = typeCast(Fdc3Portfolio.$, msg_.context);
            a.o(q.positions);
            var t = q.positions;
            for (var s = 0; s < t.length; s++) {
                var r = t[s];
                var u = r.instrument.ticker;
                if (!c.contains(u)) {
                    c.add(r.instrument.ticker);
                }
                var v = r.instrument.name;
                if (!d.contains(v)) {
                    d.add(v);
                }
            }
        }
        msg_.tickerSymbols = this.f(String_$type, c);
        msg_.tickerNames = this.f(String_$type, d);
        this.log("HandleIntent tickerSymbols " + msg_.tickerSymbols);
        this.log("HandleIntent instrumentList " + b.count);
        this.log("HandleIntent positionList " + a.count);
        try {
            for (var _c = __values(fromEnum(b)), _d = _c.next(); !_d.done; _d = _c.next()) {
                var w = _d.value;
                var x = w.ticker;
                if (stringIsNullOrEmpty(x)) {
                    continue;
                }
                var y = this.q(x);
                this.ao(x, y);
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_d && !_d.done && (_a = _c.return))
                    _a.call(_c);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        try {
            for (var _e = __values(fromEnum(a)), _f = _e.next(); !_f.done; _f = _e.next()) {
                var z = _f.value;
                var aa = z.instrument.ticker;
                if (stringIsNullOrEmpty(aa)) {
                    continue;
                }
                var ab = this.p(aa);
                if (z.cost > 0) {
                    ab.costPerShare = z.cost;
                }
                if (z.shares > 0) {
                    ab.shares = z.shares;
                }
                if (z.price > 0) {
                    ab.marketPrice = z.price;
                }
                this.an(aa, ab);
            }
        }
        catch (e_2_1) {
            e_2 = { error: e_2_1 };
        }
        finally {
            try {
                if (_f && !_f.done && (_b = _e.return))
                    _b.call(_e);
            }
            finally {
                if (e_2)
                    throw e_2.error;
            }
        }
        this.ba(msg_);
    };
    Fdc3DataAdapter.prototype.sendInstrument = function (a, b, c) {
        if (c === void 0) {
            c = "";
        }
        if (b == null) {
            return;
        }
        var d = Fdc3Converter.fromInstrument(b);
        this.bb(a, d, c);
    };
    Fdc3DataAdapter.prototype.sendInstrumentList = function (a, b, c) {
        if (c === void 0) {
            c = "";
        }
        if (b == null) {
            return;
        }
        var d = Fdc3Converter.fromInstrumentList(b);
        this.bb(a, d, c);
    };
    Fdc3DataAdapter.prototype.sendPosition = function (a, b, c) {
        if (c === void 0) {
            c = "";
        }
        if (b == null) {
            return;
        }
        var d = Fdc3Converter.fromPosition(b);
        this.bb(a, d, c);
    };
    Fdc3DataAdapter.prototype.sendPortfolio = function (a, b, c) {
        if (c === void 0) {
            c = "";
        }
        if (b == null) {
            return;
        }
        var d = Fdc3Converter.fromPortfolio(b);
        this.bb(a, d, c);
    };
    Fdc3DataAdapter.prototype.bb = function (intent_, context_, target_) {
        if (target_ === void 0) {
            target_ = "";
        }
        if (!this.a5()) {
            return;
        }
        var raiseIntent_ = this._openFin.raiseIntent;
        this.log('Sending \'' + intent_ + '\' intent to \'' + target_ + '\' target');
        // calling OpenFin API: 
        if (target_ == null || target_ === '') {
            raiseIntent_(intent_, context_); // send to all OpenFin apps
        }
        else {
            raiseIntent_(intent_, context_, target_); // send only to Target app
        }
        ;
    };
    Object.defineProperty(Fdc3DataAdapter.prototype, "a4", {
        get: function () {
            return this.a3;
        },
        set: function (a) {
            this.a3 = a;
        },
        enumerable: false,
        configurable: true
    });
    Fdc3DataAdapter.prototype.a7 = function (a) {
        this.a4 = true;
    };
    Fdc3DataAdapter.prototype.dispose = function () {
        this.a7(true);
    };
    Fdc3DataAdapter.$t = markType(Fdc3DataAdapter, 'Fdc3DataAdapter', FinancialDataAdapter.$, [IDisposable_$type]);
    return Fdc3DataAdapter;
}(FinancialDataAdapter));

/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
/**
 * @hidden
 */
var Randomizer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(Randomizer, _super);
    function Randomizer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Randomizer.d = function (a) {
        var b = "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        var c = "";
        for (var d = 0; d < a; d++) {
            var e = Randomizer.c.next1(b.length);
            c += b.charAt(e);
        }
        return c;
    };
    Randomizer.b = function (a, b) {
        return Randomizer.c.next2(a, b);
    };
    Randomizer.a = function (a) {
        var b = Math.pow(10, (a - 1));
        var c = 9 * b;
        return Randomizer.c.next2(truncate(b), truncate(c));
    };
    Randomizer.$t = markType(Randomizer, 'Randomizer');
    Randomizer.c = new Random(0);
    return Randomizer;
}(Base));

export { Fdc3Contact, Fdc3ContactList, Fdc3Context, Fdc3ContextType, Fdc3ContextType_$type, Fdc3Converter, Fdc3DataAdapter, Fdc3Dictionary, Fdc3Instrument, Fdc3InstrumentList, Fdc3IntentType, Fdc3IntentType_$type, Fdc3Message, Fdc3Organization, Fdc3OrganizationList, Fdc3Portfolio, Fdc3Position, Fdc3Serializer, Fdc3Util, Randomizer };
