import { Type } from "igniteui-webcomponents-core";
/**
 * Specifies type of FDC3 context
 *  https://fdc3.finos.org/docs/1.0/context-spec
 *
 */
export declare enum Fdc3ContextType {
    /**
     * Specifies a context that is unknown by FDC3 data adapter
     */
    Unknown = 0,
    /**
     * Specifies FDC3 context for single instrument with stock name, stock ticker/symbol
     */
    Instrument = 1,
    /**
     * Specifies FDC3 context for multiple instrument
     */
    InstrumentList = 2,
    /**
     * Specifies FDC3 context for single position
     */
    Position = 3,
    /**
     * Specifies FDC3 context for multiple positions
     */
    Portfolio = 4,
    /**
     * Currently not supported - Specifies FDC3 context for single contact with person name, email, phone, etc.
     */
    Contact = 5,
    /**
     * Currently not supported - Specifies FDC3 context for multiple contacts
     */
    ContactList = 6,
    /**
     * Currently not supported - Specifies FDC3 context for single organization with company name
     */
    Organization = 7,
    /**
     * Currently not supported - Specifies FDC3 context for multiple organizations
     */
    OrganizationList = 8
}
/**
 * @hidden
 */
export declare let Fdc3ContextType_$type: Type;
