import { Base, Type } from "igniteui-webcomponents-core";
import { Fdc3IntentType } from "./Fdc3IntentType";
import { Fdc3Dictionary } from "./Fdc3Dictionary";
import { Fdc3ContextType } from "./Fdc3ContextType";
/**
 * @hidden
 */
export declare class Fdc3Serializer extends Base {
    static $t: Type;
    constructor();
    toString(): string;
    private _sb;
    private m;
    private l;
    toJson(a: Fdc3Context): string;
    add4(a: Fdc3Instrument, b?: string): void;
    add5(a: Fdc3InstrumentList): void;
    add8(a: Fdc3Portfolio): void;
    add9(a: Fdc3Position, b?: string): void;
    add1(a: Fdc3Contact, b?: string): void;
    z(message_: string): void;
    add2(a: Fdc3ContactList): void;
    add6(a: Fdc3Organization, b?: string): void;
    add7(a: Fdc3OrganizationList): void;
    add3(a: Fdc3Context, b?: string): void;
    addArrayOpen(): Fdc3Serializer;
    addArrayClose(a?: string): Fdc3Serializer;
    addObjectOpen(): Fdc3Serializer;
    addObjectClose(a?: string): Fdc3Serializer;
    add(a: string): Fdc3Serializer;
    addLine(a: string): Fdc3Serializer;
    addProp(a: string): Fdc3Serializer;
    addProp1(a: string, b: any, c?: string): Fdc3Serializer;
    private i;
    tabIncrease(): Fdc3Serializer;
    tabDecrease(): Fdc3Serializer;
}
/**
 * @hidden
 */
export declare class Fdc3Context extends Fdc3Dictionary {
    static $t: Type;
    constructor(a: number);
    constructor(a: number, b: Fdc3ContextType);
    constructor(a: number, ..._rest: any[]);
    get intent(): Fdc3IntentType;
    set intent(a: Fdc3IntentType);
    get type(): string;
    set type(a: string);
    get target(): string;
    set target(a: string);
    get name(): string;
    set name(a: string);
    private _id;
    get id(): Fdc3Dictionary;
    set id(a: Fdc3Dictionary);
    toJson(): string;
}
/**
 * @hidden
 */
export declare class Fdc3Instrument extends Fdc3Context {
    static $t: Type;
    constructor();
    get ticker(): string;
    set ticker(a: string);
}
/**
 * @hidden
 */
export declare class Fdc3InstrumentList extends Fdc3Context {
    static $t: Type;
    constructor();
    private _instruments;
    get instruments(): Fdc3Instrument[];
    set instruments(a: Fdc3Instrument[]);
}
/**
 * @hidden
 */
export declare class Fdc3Position extends Fdc3Context {
    static $t: Type;
    constructor();
    get instrument(): Fdc3Instrument;
    set instrument(a: Fdc3Instrument);
    get shares(): number;
    set shares(a: number);
    get cost(): number;
    set cost(a: number);
    get price(): number;
    set price(a: number);
}
/**
 * @hidden
 */
export declare class Fdc3Portfolio extends Fdc3Context {
    static $t: Type;
    constructor();
    private _positions;
    get positions(): Fdc3Position[];
    set positions(a: Fdc3Position[]);
}
/**
 * @hidden
 */
export declare class Fdc3Organization extends Fdc3Context {
    static $t: Type;
    constructor();
}
/**
 * @hidden
 */
export declare class Fdc3OrganizationList extends Fdc3Context {
    static $t: Type;
    constructor();
    private _organizations;
    get organizations(): Fdc3Instrument[];
    set organizations(a: Fdc3Instrument[]);
}
/**
 * @hidden
 */
export declare class Fdc3Contact extends Fdc3Context {
    static $t: Type;
    constructor(a: number);
    constructor(a: number, b: string, c: string, d: string, e?: string);
    constructor(a: number, ..._rest: any[]);
    get email(): string;
    set email(a: string);
    get phone(): string;
    set phone(a: string);
    get twitter(): string;
    set twitter(a: string);
}
/**
 * @hidden
 */
export declare class Fdc3ContactList extends Fdc3Context {
    static $t: Type;
    constructor(a: number);
    constructor(a: number, b: Fdc3Contact[]);
    constructor(a: number, ..._rest: any[]);
    private _contacts;
    get contacts(): Fdc3Contact[];
    set contacts(a: Fdc3Contact[]);
}
